var grammar;
var prophecy;
var seed = -1;

window.onload = function () {
  handleSeed();
  initGrammar();
  genProphecy();
};


function initGrammar() {
  console.log(tracery.rng)
  grammar = tracery.createGrammar(grammar_json);
  grammar.addModifiers(baseEngModifiers);
}


function handleSeed() {
  if (seedCookieExists()) {
    console.log("seed!");
    seed = parseInt(getCookie("seed")); //cookie values are handled as strings by default
  } else {
    console.log("no seed!");
    seed = generateSeed();
    setCookie(seed);
  }

  console.log("tracery seed:"+seed);
  var myRng = new Math.seedrandom(seed);
  tracery.setRng(myRng);
}


function seedCookieExists() {
  return getCookie("seed") != "";
}


function midnight_cookie(name, value, path)
{
  var now = new Date();
  var expire = new Date();
  expire.setFullYear(now.getFullYear());
  expire.setMonth(now.getMonth());
  expire.setDate(now.getDate()+1);
  expire.setHours(0);
  expire.setMinutes(0);
  document.cookie = name+"="+value+"; expires=" + expire.toString() +"; path=" + path;
}


function setCookie(seed) {
  console.log("setting cookie");
  midnight_cookie("seed",seed,"/");
}


function getCookie(cname) {
  let name = cname + "=";
  let decodedCookie = decodeURIComponent(document.cookie);
  console.log(decodedCookie);
  let ca = decodedCookie.split(';');
  for (let i = 0; i < ca.length; i++) {
    let c = ca[i];
    console.log(c);
    while (c.charAt(0) == ' ') {
      c = c.substring(1);
    }
    if (c.indexOf(name) == 0) {
      return c.substring(name.length, c.length);
    }
  }
  return "";
}


function generateSeed(){
  min = Number.MIN_SAFE_INTEGER;
  max = Number.MAX_SAFE_INTEGER;
  seed = Math.floor(Math.random() * (max - min + 1)) + min;
  return seed;
}


function genProphecy() {
  prophecy = grammar.flatten("#origin#");
  web_prophecy = prophecy.replace(/\n/g,"<br>");
  document.getElementById("prophecy").innerHTML = web_prophecy;
}


function copyProphecy() {
  /* Get the text field */
  const copyText = generateCopyText();
  copyToClipboard(copyText);
  animateCopyButton();
}


function generateCopyText() {
  const today = new Date();
  console.log(prophecy);
  return "Emophecy " + today.toLocaleDateString("en-US") + "\n" + prophecy;
}


function copyToClipboard(text) {
  var emptyArea = document.createElement('textarea');
  emptyArea.innerHTML = text;
  const parentElement = document.querySelector(':root');
  parentElement.appendChild(emptyArea);
 
  emptyArea.select();
  document.execCommand('copy');
 
  parentElement.removeChild(emptyArea);
}


function animateCopyButton() {
  document.getElementById("copy").innerText = "✅";
  setTimeout(() => {  document.getElementById("copy").innerText = "📋";}, 2000);
}

